
var monitor = {}
monitor.processes = {}
monitor.processes.fetch = function(){
	var httpclient = HttpClient.instance()
	httpclient.get('/get/processes',monitor.processes.init);
	
}

monitor.processes.init = function(x){
	var r = JSON.parse(x.responseText)
	var keys = jx.utils.keys(r)	
	jx.dom.set.value('menu','')
	jx.utils.patterns.visitor(keys,function(label){
		var div = jx.dom.get.instance('DIV')
		var frame= jx.dom.get.instance('DIV')
		var i	= jx.dom.get.instance('I')
		i.className = 'fa fa-chevron-right left'
		
		div.innerHTML	= label
		frame.data	= r[label]
		frame.label	= label
		frame.appendChild(i)
		frame.appendChild(div)
		frame.className = 'menu-item'
		frame.onclick = function () {
			monitor.processes.render(this.label, this.data);
			monitor.processes.trend.init(this.label)
		}
		jx.dom.append('menu',frame)
	})
}
monitor.processes.render = function(label,data) {
	
	data = jx.utils.patterns.visitor(data,function(row){
		var status = {"idle":'<i class="fa fa-ellipsis-h" title="IDLE"></i>',"running":'<i class="fa fa-check" title="RUNNING"></i>',"crash":'<i class="fa fa-times" title="CRASHED"></i>'}	
		if (!row.status.match(/class/)) {
			row.status_id = row.status
			row.status = status[row.status]		
			
		}
		return row
	})
	jx.dom.set.value('latest_processes','') ;
	jx.dom.set.value('latest_processes_label',label)
	var options = {width:'90%'}
	
	options.data = data
	options.rowClass = function (item, index,evt) {
		
		return 'small'
	}
	options.autoload  = true
	options.fields = [{name:'label',type:'text',title:"Process",headercss:"small bold",css:"small"},{name:"cpu_usage",type:"number",title:"CPU", headercss:"small bold"},{name:"memory_usage",type:"text",title:"Mem. Used",type:"number",headercss:"small bold"},{name:"memory_available",type:"number",title:"Mem. Avail",headercss:"small bold"},
	{name:"status",type:"text",title:"Status",headercss:"small bold",align:"center"}
	]
	var grid = $('#latest_processes').jsGrid(options) ;


}

monitor.processes.trend = {}
monitor.processes.trend.init = function (label) {
	var httpclient = HttpClient.instance()
	var uri = '/trends?id='+label
	httpclient.get(uri, function (x) {
		var logs = JSON.parse(x.responseText)
		// jx.dom.set.attribute(label,'logs',logs)
		monitor.processes.trend.render(logs)
	})
}
monitor.processes.trend.render = function (logs, key) {
	if (key == null) {
		key = 'memory_usage'
	}
	var context = $('#trends_chart')
	var conf = { type: 'line' }
	conf.data = {}
	conf.options = { legend: { position: 'bottom' } }
	conf.options.scales = {}
	conf.options.scales.yAxes = [{ title: {display:true,text:key},gridLines: {display:false}}]
	conf.options.scales.xAxes = [
		{
			
			type: 'time',
			gridLines: {display:false},
			time: {
				format:'dd-MMM HH:mm'
			}
			
		}
		
	]
	// conf.data.labels = x_axis
	var p = jx.utils.keys(logs)
	conf.data.datasets = [	]
	var labels = []
	var i = 0;
	
	for (id in logs) {
		var serie = {}
		serie.label = id
		serie.data = jx.utils.patterns.visitor(logs[id], function (item) {
			// x = parseFloat(item['hour'] + '.' + item['minute']).toFixed(2)
			x = new Date(item.year,item.month-1,item.day,item.hour,item.minute)
			y = item[key]
			labels.push(x)
			console.log([item.day,item.hour,item.minute])
			return {x:x,y:y}
		})
		
		serie.backgroundColor = ['transparent']
		serie.borderColor = COLORS[i]
		serie.borderWidth = 1
		++i
		conf.data.datasets.push(serie)
		

	}
	
	labels = jx.utils.unique(labels)
	console.log(labels)
	conf.data.labels = labels
	// console.log(conf)
	var chart = new Chart(context,conf)

}